// Generated by CoffeeScript 1.6.3
(function() {
  var Argument, BranchPattern, Command, Dict, DocoptExit, DocoptLanguageError, Either, LeafPattern, OneOrMore, Option, Optional, OptionsShortcut, Pattern, Required, Tokens, any, docopt, enumerate, extras, formal_usage, parse_argv, parse_atom, parse_defaults, parse_expr, parse_long, parse_pattern, parse_section, parse_seq, parse_shorts, print, transform, zip, _ref, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; },
    __slice = [].slice,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  print = function() {
    return console.log([].join.call(arguments, ' '));
  };

  enumerate = function(array) {
    var i, item, _i, _len, _results;
    i = 0;
    _results = [];
    for (_i = 0, _len = array.length; _i < _len; _i++) {
      item = array[_i];
      _results.push([i++, item]);
    }
    return _results;
  };

  any = function(array) {
    return __indexOf.call(array, true) >= 0;
  };

  zip = function() {
    var args, arr, i, length, lengthArray, _i, _results;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    lengthArray = (function() {
      var _i, _len, _results;
      _results = [];
      for (_i = 0, _len = args.length; _i < _len; _i++) {
        arr = args[_i];
        _results.push(arr.length);
      }
      return _results;
    })();
    length = Math.min.apply(Math, lengthArray);
    _results = [];
    for (i = _i = 0; 0 <= length ? _i < length : _i > length; i = 0 <= length ? ++_i : --_i) {
      _results.push((function() {
        var _j, _len, _results1;
        _results1 = [];
        for (_j = 0, _len = args.length; _j < _len; _j++) {
          arr = args[_j];
          _results1.push(arr[i]);
        }
        return _results1;
      })());
    }
    return _results;
  };

  String.prototype.partition = function(separator) {
    var parts, self;
    self = this;
    if (self.indexOf(separator) >= 0) {
      parts = self.split(separator);
      return [parts[0], separator, parts.slice(1).join(separator)];
    } else {
      return [String(self), '', ''];
    }
  };

  String.prototype.startsWith = function(searchString, position) {
    position = position || 0;
    return this.lastIndexOf(searchString, position) === position;
  };

  String.prototype.endsWith = function(searchString, position) {
    var lastIndex, subjectString;
    subjectString = this.toString();
    if (position === void 0 || position > subjectString.length) {
      position = subjectString.length;
    }
    position -= searchString.length;
    lastIndex = subjectString.indexOf(searchString, position);
    return lastIndex !== -1 && lastIndex === position;
  };

  String.prototype._split = function() {
    return this.trim().split(/\s+/).filter(function(i) {
      return i !== '';
    });
  };

  String.prototype.isUpper = function() {
    return /^[A-Z]+$/g.exec(this);
  };

  Number.isInteger = Number.isInteger || function(value) {
    return typeof value === "number" && isFinite(value) && Math.floor(value) === value;
  };

  DocoptLanguageError = (function(_super) {
    __extends(DocoptLanguageError, _super);

    function DocoptLanguageError(message) {
      this.message = message;
      DocoptLanguageError.__super__.constructor.call(this, this.message);
    }

    return DocoptLanguageError;

  })(Error);

  DocoptExit = (function(_super) {
    __extends(DocoptExit, _super);

    function DocoptExit(message) {
      this.message = message;
      DocoptExit.__super__.constructor.call(this, this.message);
    }

    return DocoptExit;

  })(Error);

  Pattern = (function(_super) {
    __extends(Pattern, _super);

    function Pattern() {
      _ref = Pattern.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    Pattern.prototype.fix = function() {
      this.fix_identities();
      this.fix_repeating_arguments();
      return this;
    };

    Pattern.prototype.fix_identities = function(uniq) {
      var c, flat, i, k, _i, _j, _len, _len1, _ref1, _ref2, _ref3;
      if (uniq == null) {
        uniq = null;
      }
      "Make pattern-tree tips point to same object if they are equal.";
      if (!this.hasOwnProperty('children')) {
        return this;
      }
      if (uniq === null) {
        _ref1 = [{}, this.flat()], uniq = _ref1[0], flat = _ref1[1];
        for (_i = 0, _len = flat.length; _i < _len; _i++) {
          k = flat[_i];
          uniq[k] = k;
        }
      }
      _ref2 = enumerate(this.children);
      for (_j = 0, _len1 = _ref2.length; _j < _len1; _j++) {
        _ref3 = _ref2[_j], i = _ref3[0], c = _ref3[1];
        if (!c.hasOwnProperty('children')) {
          console.assert(uniq.hasOwnProperty(c));
          this.children[i] = uniq[c];
        } else {
          c.fix_identities(uniq);
        }
      }
      return this;
    };

    Pattern.prototype.fix_repeating_arguments = function() {
      "Fix elements that should accumulate/increment values.";
      var c, child, counts, e, either, mycase, _i, _j, _k, _len, _len1, _len2, _ref1;
      either = (function() {
        var _i, _len, _ref1, _results;
        _ref1 = transform(this).children;
        _results = [];
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          child = _ref1[_i];
          _results.push(child.children);
        }
        return _results;
      }).call(this);
      for (_i = 0, _len = either.length; _i < _len; _i++) {
        mycase = either[_i];
        counts = {};
        for (_j = 0, _len1 = mycase.length; _j < _len1; _j++) {
          c = mycase[_j];
          counts[c] = (counts[c] ? counts[c] : 0) + 1;
        }
        _ref1 = (function() {
          var _l, _len2, _results;
          _results = [];
          for (_l = 0, _len2 = mycase.length; _l < _len2; _l++) {
            child = mycase[_l];
            if (counts[child] > 1) {
              _results.push(child);
            }
          }
          return _results;
        })();
        for (_k = 0, _len2 = _ref1.length; _k < _len2; _k++) {
          e = _ref1[_k];
          if (e.constructor === Argument || e.constructor === Option && e.argcount) {
            if (e.value === null) {
              e.value = [];
            } else if (e.value.constructor !== Array) {
              e.value = e.value._split();
            }
          }
          if (e.constructor === Command || e.constructor === Option && e.argcount === 0) {
            e.value = 0;
          }
        }
      }
      return this;
    };

    return Pattern;

  })(Object);

  transform = function(pattern) {
    "Expand pattern into an (almost) equivalent one, but with single Either.\n\nExample: ((-a | -b) (-c | -d)) => (-a -c | -a -d | -b -c | -b -d)\nQuirks: [-a] => (-a), (-a...) => (-a -a)\n";
    var c, child, children, e, groups, index, parents, result, t, _i, _len, _ref1;
    result = [];
    groups = [[pattern]];
    while (groups.length) {
      children = groups.shift();
      parents = [Required, Optional, OptionsShortcut, Either, OneOrMore];
      if (any((function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = parents.length; _i < _len; _i++) {
          t = parents[_i];
          _results.push(__indexOf.call(children.map(function(c) {
            return c.constructor;
          }), t) >= 0);
        }
        return _results;
      })())) {
        child = ((function() {
          var _i, _len, _ref1, _results;
          _results = [];
          for (_i = 0, _len = children.length; _i < _len; _i++) {
            c = children[_i];
            if (_ref1 = c.constructor, __indexOf.call(parents, _ref1) >= 0) {
              _results.push(c);
            }
          }
          return _results;
        })())[0];
        index = children.indexOf(child);
        if (index >= 0) {
          children.splice(index, 1);
        }
        if (child.constructor === Either) {
          _ref1 = child.children;
          for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
            c = _ref1[_i];
            groups.push([c].concat(children));
          }
        } else if (child.constructor === OneOrMore) {
          groups.push((child.children.concat(child.children)).concat(children));
        } else {
          groups.push(child.children.concat(children));
        }
      } else {
        result.push(children);
      }
    }
    return new Either((function() {
      var _j, _len1, _results;
      _results = [];
      for (_j = 0, _len1 = result.length; _j < _len1; _j++) {
        e = result[_j];
        _results.push(new Required(e));
      }
      return _results;
    })());
  };

  LeafPattern = (function(_super) {
    __extends(LeafPattern, _super);

    "Leaf/terminal node of a pattern tree.";

    function LeafPattern(name, value) {
      this.name = name;
      this.value = value != null ? value : null;
    }

    LeafPattern.prototype.toString = function() {
      return "" + this.constructor.name + "(" + this.name + ", " + this.value + ")";
    };

    LeafPattern.prototype.flat = function(types) {
      var _ref1;
      if (types == null) {
        types = [];
      }
      types = types instanceof Array ? types : [types];
      if (!types.length || (_ref1 = this.constructor, __indexOf.call(types, _ref1) >= 0)) {
        return [this];
      } else {
        return [];
      }
    };

    LeafPattern.prototype.match = function(left, collected) {
      var a, increment, left_, match, pos, same_name, _ref1;
      if (collected == null) {
        collected = null;
      }
      if (collected === null) {
        collected = [];
      }
      _ref1 = this.singleMatch(left), pos = _ref1[0], match = _ref1[1];
      if (match === null) {
        return [false, left, collected];
      }
      left_ = left.slice(0, pos).concat(left.slice(pos + 1));
      same_name = (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = collected.length; _i < _len; _i++) {
          a = collected[_i];
          if (a.name === this.name) {
            _results.push(a);
          }
        }
        return _results;
      }).call(this);
      if (Number.isInteger(this.value) || this.value instanceof Array) {
        if (Number.isInteger(this.value)) {
          increment = 1;
        } else {
          increment = typeof match.value === 'string' ? [match.value] : match.value;
        }
        if (!same_name.length) {
          match.value = increment;
          return [true, left_, collected.concat(match)];
        }
        if (Number.isInteger(this.value)) {
          same_name[0].value += increment;
        } else {
          same_name[0].value = [].concat(same_name[0].value, increment);
        }
        return [true, left_, collected];
      }
      return [true, left_, collected.concat(match)];
    };

    return LeafPattern;

  })(Pattern);

  BranchPattern = (function(_super) {
    __extends(BranchPattern, _super);

    "Branch/inner node of a pattern tree.";

    function BranchPattern(children) {
      this.children = children instanceof Array ? children : [children];
    }

    BranchPattern.prototype.toString = function() {
      var a;
      return "" + this.constructor.name + "(" + (((function() {
        var _i, _len, _ref1, _results;
        _ref1 = this.children;
        _results = [];
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          a = _ref1[_i];
          _results.push(a);
        }
        return _results;
      }).call(this)).join(', ')) + ")";
    };

    BranchPattern.prototype.flat = function(types) {
      var child, _ref1;
      if (types == null) {
        types = [];
      }
      types = types instanceof Array ? types : [types];
      if (_ref1 = this.constructor, __indexOf.call(types, _ref1) >= 0) {
        return [this];
      }
      return ((function() {
        var _i, _len, _ref2, _results;
        _ref2 = this.children;
        _results = [];
        for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
          child = _ref2[_i];
          if (child instanceof Pattern) {
            _results.push(child.flat(types));
          }
        }
        return _results;
      }).call(this)).reduce((function(pv, cv) {
        return [].concat(pv, cv);
      }), []);
    };

    return BranchPattern;

  })(Pattern);

  Argument = (function(_super) {
    __extends(Argument, _super);

    function Argument() {
      _ref1 = Argument.__super__.constructor.apply(this, arguments);
      return _ref1;
    }

    Argument.prototype.singleMatch = function(left) {
      var n, pattern, _i, _len, _ref2, _ref3;
      _ref2 = enumerate(left);
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        _ref3 = _ref2[_i], n = _ref3[0], pattern = _ref3[1];
        if (pattern.constructor === Argument) {
          return [n, new Argument(this.name, pattern.value)];
        }
      }
      return [null, null];
    };

    Argument.parse = function(source) {
      var name, value;
      name = /(<\S*?>)/ig.exec(source)[1];
      value = /\[default:\s+(.*)\]/ig.exec(source);
      return new Argument(name, value ? value[1] : null);
    };

    return Argument;

  })(LeafPattern);

  Command = (function(_super) {
    __extends(Command, _super);

    function Command(name, value) {
      this.name = name;
      this.value = value != null ? value : false;
    }

    Command.prototype.singleMatch = function(left) {
      var n, pattern, _i, _len, _ref2, _ref3;
      _ref2 = enumerate(left);
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        _ref3 = _ref2[_i], n = _ref3[0], pattern = _ref3[1];
        if (pattern.constructor === Argument) {
          if (pattern.value === this.name) {
            return [n, new Command(this.name, true)];
          } else {
            break;
          }
        }
      }
      return [null, null];
    };

    return Command;

  })(Argument);

  Option = (function(_super) {
    __extends(Option, _super);

    function Option(short, long, argcount, value) {
      var _ref2;
      this.short = short != null ? short : null;
      this.long = long != null ? long : null;
      this.argcount = argcount != null ? argcount : 0;
      if (value == null) {
        value = false;
      }
      console.assert((_ref2 = this.argcount) === 0 || _ref2 === 1);
      this.value = value === false && this.argcount > 0 ? null : value;
      this.name = this.long || this.short;
    }

    Option.prototype.toString = function() {
      return "Option(" + this.short + ", " + this.long + ", " + this.argcount + ", " + this.value + ")";
    };

    Option.parse = function(option_description) {
      var argcount, description, long, matched, options, s, short, value, _, _i, _len, _ref2, _ref3, _ref4;
      _ref2 = [null, null, 0, false], short = _ref2[0], long = _ref2[1], argcount = _ref2[2], value = _ref2[3];
      _ref3 = option_description.trim().partition('  '), options = _ref3[0], _ = _ref3[1], description = _ref3[2];
      options = options.replace(/,|=/g, ' ');
      _ref4 = options._split();
      for (_i = 0, _len = _ref4.length; _i < _len; _i++) {
        s = _ref4[_i];
        if (s.startsWith('--')) {
          long = s;
        } else if (s.startsWith('-')) {
          short = s;
        } else {
          argcount = 1;
        }
      }
      if (argcount > 0) {
        matched = /\[default:\s+(.*)\]/ig.exec(description);
        value = matched ? matched[1] : null;
      }
      return new Option(short, long, argcount, value);
    };

    Option.prototype.singleMatch = function(left) {
      var n, pattern, _i, _len, _ref2, _ref3;
      _ref2 = enumerate(left);
      for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
        _ref3 = _ref2[_i], n = _ref3[0], pattern = _ref3[1];
        if (this.name === pattern.name) {
          return [n, pattern];
        }
      }
      return [null, null];
    };

    return Option;

  })(LeafPattern);

  Required = (function(_super) {
    __extends(Required, _super);

    function Required() {
      _ref2 = Required.__super__.constructor.apply(this, arguments);
      return _ref2;
    }

    Required.prototype.match = function(left, collected) {
      var c, l, matched, p, _i, _len, _ref3, _ref4;
      if (collected == null) {
        collected = null;
      }
      if (collected === null) {
        collected = [];
      }
      l = left;
      c = collected;
      _ref3 = this.children;
      for (_i = 0, _len = _ref3.length; _i < _len; _i++) {
        p = _ref3[_i];
        _ref4 = p.match(l, c), matched = _ref4[0], l = _ref4[1], c = _ref4[2];
        if (!matched) {
          return [false, left, collected];
        }
      }
      return [true, l, c];
    };

    return Required;

  })(BranchPattern);

  Optional = (function(_super) {
    __extends(Optional, _super);

    function Optional() {
      _ref3 = Optional.__super__.constructor.apply(this, arguments);
      return _ref3;
    }

    Optional.prototype.match = function(left, collected) {
      var m, p, _i, _len, _ref4, _ref5;
      if (collected == null) {
        collected = null;
      }
      if (collected === null) {
        collected = [];
      }
      _ref4 = this.children;
      for (_i = 0, _len = _ref4.length; _i < _len; _i++) {
        p = _ref4[_i];
        _ref5 = p.match(left, collected), m = _ref5[0], left = _ref5[1], collected = _ref5[2];
      }
      return [true, left, collected];
    };

    return Optional;

  })(BranchPattern);

  OptionsShortcut = (function(_super) {
    __extends(OptionsShortcut, _super);

    "Marker/placeholder for [options] shortcut.";

    function OptionsShortcut() {
      _ref4 = OptionsShortcut.__super__.constructor.apply(this, arguments);
      return _ref4;
    }

    return OptionsShortcut;

  })(Optional);

  OneOrMore = (function(_super) {
    __extends(OneOrMore, _super);

    function OneOrMore() {
      _ref5 = OneOrMore.__super__.constructor.apply(this, arguments);
      return _ref5;
    }

    OneOrMore.prototype.match = function(left, collected) {
      var c, l, l_, matched, times, _ref6;
      if (collected == null) {
        collected = null;
      }
      console.assert(this.children.length === 1);
      if (collected === null) {
        collected = [];
      }
      l = left;
      c = collected;
      l_ = [];
      matched = true;
      times = 0;
      while (matched) {
        _ref6 = this.children[0].match(l, c), matched = _ref6[0], l = _ref6[1], c = _ref6[2];
        times += matched ? 1 : 0;
        if (l_.join(', ') === l.join(', ')) {
          break;
        }
        l_ = l;
      }
      if (times >= 1) {
        return [true, l, c];
      }
      return [false, left, collected];
    };

    return OneOrMore;

  })(BranchPattern);

  Either = (function(_super) {
    __extends(Either, _super);

    function Either() {
      _ref6 = Either.__super__.constructor.apply(this, arguments);
      return _ref6;
    }

    Either.prototype.match = function(left, collected) {
      var outcome, outcomes, p, _i, _len, _ref7;
      if (collected == null) {
        collected = null;
      }
      if (collected === null) {
        collected = [];
      }
      outcomes = [];
      _ref7 = this.children;
      for (_i = 0, _len = _ref7.length; _i < _len; _i++) {
        p = _ref7[_i];
        outcome = p.match(left, collected);
        if (outcome[0]) {
          outcomes.push(outcome);
        }
      }
      if (outcomes.length > 0) {
        outcomes.sort(function(a, b) {
          if (a[1].length > b[1].length) {
            return 1;
          } else if (a[1].length < b[1].length) {
            return -1;
          } else {
            return 0;
          }
        });
        return outcomes[0];
      }
      return [false, left, collected];
    };

    return Either;

  })(BranchPattern);

  Tokens = (function(_super) {
    __extends(Tokens, _super);

    function Tokens(source, error) {
      var stream;
      this.error = error != null ? error : DocoptExit;
      stream = source.constructor === String ? source._split() : source;
      this.push.apply(this, stream);
    }

    Tokens.prototype.move = function() {
      if (this.length) {
        return [].shift.apply(this);
      } else {
        return null;
      }
    };

    Tokens.prototype.current = function() {
      if (this.length) {
        return this[0];
      } else {
        return null;
      }
    };

    Tokens.from_pattern = function(source) {
      var s;
      source = source.replace(/([\[\]\(\)\|]|\.\.\.)/g, ' $1 ');
      source = (function() {
        var _i, _len, _ref7, _results;
        _ref7 = source.split(/\s+|(\S*<.*?>)/);
        _results = [];
        for (_i = 0, _len = _ref7.length; _i < _len; _i++) {
          s = _ref7[_i];
          if (s) {
            _results.push(s);
          }
        }
        return _results;
      })();
      return new Tokens(source, DocoptLanguageError);
    };

    return Tokens;

  })(Array);

  parse_section = function(name, source) {
    var matches, s;
    matches = source.match(new RegExp('^([^\n]*' + name + '[^\n]*\n?(?:[ \t].*?(?:\n|$))*)', 'igm'));
    if (matches) {
      return (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = matches.length; _i < _len; _i++) {
          s = matches[_i];
          _results.push(s.trim());
        }
        return _results;
      })();
    }
    return [];
  };

  parse_shorts = function(tokens, options) {
    "shorts ::= '-' ( chars )* [ [ ' ' ] chars ] ;";
    var left, o, parsed, short, similar, token, value, _ref7, _ref8;
    token = tokens.move();
    console.assert(token.startsWith('-') && !token.startsWith('--'));
    left = token.replace(/^-+/g, '');
    parsed = [];
    while (left !== '') {
      _ref7 = ['-' + left[0], left.slice(1)], short = _ref7[0], left = _ref7[1];
      similar = (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = options.length; _i < _len; _i++) {
          o = options[_i];
          if (o.short === short) {
            _results.push(o);
          }
        }
        return _results;
      })();
      if (similar.length > 1) {
        throw new tokens.error("" + short + " is specified ambiguously " + similar.length + " times");
      } else if (similar.length < 1) {
        o = new Option(short, null, 0);
        options.push(o);
        if (tokens.error === DocoptExit) {
          o = new Option(short, null, 0, true);
        }
      } else {
        o = new Option(short, similar[0].long, similar[0].argcount, similar[0].value);
        value = null;
        if (o.argcount !== 0) {
          if (left === '') {
            if ((_ref8 = tokens.current()) === null || _ref8 === '--') {
              throw new tokens.error("" + short + " requires argument");
            }
            value = tokens.move();
          } else {
            value = left;
            left = '';
          }
        }
        if (tokens.error === DocoptExit) {
          o.value = value !== null ? value : true;
        }
      }
      parsed.push(o);
    }
    return parsed;
  };

  parse_long = function(tokens, options) {
    "long ::= '--' chars [ ( ' ' | '=' ) chars ] ;";
    var argcount, eq, long, longs, o, similar, value, _ref7, _ref8;
    _ref7 = tokens.move().partition('='), long = _ref7[0], eq = _ref7[1], value = _ref7[2];
    console.assert(long.startsWith('--'));
    if (eq === value && value === '') {
      value = null;
    }
    similar = (function() {
      var _i, _len, _results;
      _results = [];
      for (_i = 0, _len = options.length; _i < _len; _i++) {
        o = options[_i];
        if (o.long === long) {
          _results.push(o);
        }
      }
      return _results;
    })();
    if (tokens.error === DocoptExit && similar.length === 0) {
      similar = (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = options.length; _i < _len; _i++) {
          o = options[_i];
          if (o.long && o.long.startsWith(long)) {
            _results.push(o);
          }
        }
        return _results;
      })();
    }
    if (similar.length > 1) {
      longs = ((function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = similar.length; _i < _len; _i++) {
          o = similar[_i];
          _results.push(o.long);
        }
        return _results;
      })()).join(', ');
      throw new tokens.error("" + long + " is not a unique prefix: " + longs + "?");
    } else if (similar.length < 1) {
      argcount = eq === '=' ? 1 : 0;
      o = new Option(null, long, argcount);
      options.push(o);
      if (tokens.error === DocoptExit) {
        o = new Option(null, long, argcount, argcount > 0 ? value : true);
      }
    } else {
      o = new Option(similar[0].short, similar[0].long, similar[0].argcount, similar[0].value);
      if (o.argcount === 0) {
        if (value !== null) {
          throw new tokens.error("" + o.long + " must not have an argument");
        }
      } else {
        if (value === null) {
          if ((_ref8 = tokens.current()) === null || _ref8 === '--') {
            throw new tokens.error("" + o.long + " requires argument");
          }
          value = tokens.move();
        }
      }
      if (tokens.error === DocoptExit) {
        o.value = value !== null ? value : true;
      }
    }
    return [o];
  };

  parse_pattern = function(source, options) {
    var result, tokens;
    tokens = Tokens.from_pattern(source);
    result = parse_expr(tokens, options);
    if (tokens.current() !== null) {
      throw new tokens.error('unexpected ending: ' + (tokens.join(' ')));
    }
    return new Required(result);
  };

  parse_expr = function(tokens, options) {
    "expr ::= seq ( '|' seq )* ;";
    var result, seq;
    seq = parse_seq(tokens, options);
    if (tokens.current() !== '|') {
      return seq;
    }
    result = seq.length > 1 ? [new Required(seq)] : seq;
    while (tokens.current() === '|') {
      tokens.move();
      seq = parse_seq(tokens, options);
      result = result.concat(seq.length > 1 ? [new Required(seq)] : seq);
    }
    if (result.length > 1) {
      return [new Either(result)];
    } else {
      return result;
    }
  };

  parse_seq = function(tokens, options) {
    "seq ::= ( atom [ '...' ] )* ;";
    var atom, result, _ref7;
    result = [];
    while ((_ref7 = tokens.current()) !== null && _ref7 !== ']' && _ref7 !== ')' && _ref7 !== '|') {
      atom = parse_atom(tokens, options);
      if (tokens.current() === '...') {
        atom = [new OneOrMore(atom)];
        tokens.move();
      }
      result = result.concat(atom);
    }
    return result;
  };

  parse_atom = function(tokens, options) {
    "atom ::= '(' expr ')' | '[' expr ']' | 'options'\n| long | shorts | argument | command ;";
    var matching, patternType, result, token, _ref7;
    token = tokens.current();
    result = [];
    if (__indexOf.call('([', token) >= 0) {
      tokens.move();
      _ref7 = {
        '(': [')', Required],
        '[': [']', Optional]
      }[token], matching = _ref7[0], patternType = _ref7[1];
      result = new patternType(parse_expr(tokens, options));
      if (tokens.move() !== matching) {
        throw new tokens.error("Unmatched '" + token + "'");
      }
      return [result];
    } else if (token === 'options') {
      tokens.move();
      return [new OptionsShortcut];
    } else if (token.startsWith('--') && token !== '--') {
      return parse_long(tokens, options);
    } else if (token.startsWith('-') && (token !== '-' && token !== '--')) {
      return parse_shorts(tokens, options);
    } else if (token.startsWith('<') && token.endsWith('>') || token.isUpper()) {
      return [new Argument(tokens.move())];
    } else {
      return [new Command(tokens.move())];
    }
  };

  parse_argv = function(tokens, options, options_first) {
    var parsed, v;
    if (options_first == null) {
      options_first = false;
    }
    "Parse command-line argument vector.\nIf options_first:\n    argv ::= [ long | shorts ]* [ argument ]* [ '--' [ argument ]* ] ;\nelse:\n    argv ::= [ long | shorts | argument ]* [ '--' [ argument ]* ] ;";
    parsed = [];
    while (tokens.current() !== null) {
      if (tokens.current() === '--') {
        return parsed.concat((function() {
          var _i, _len, _results;
          _results = [];
          for (_i = 0, _len = tokens.length; _i < _len; _i++) {
            v = tokens[_i];
            _results.push(new Argument(null, v));
          }
          return _results;
        })());
      } else if (tokens.current().startsWith('--')) {
        parsed = parsed.concat(parse_long(tokens, options));
      } else if (tokens.current().startsWith('-') && tokens.current() !== '-') {
        parsed = parsed.concat(parse_shorts(tokens, options));
      } else if (options_first) {
        return parsed.concat((function() {
          var _i, _len, _results;
          _results = [];
          for (_i = 0, _len = tokens.length; _i < _len; _i++) {
            v = tokens[_i];
            _results.push(new Argument(null, v));
          }
          return _results;
        })());
      } else {
        parsed.push(new Argument(null, tokens.move()));
      }
    }
    return parsed;
  };

  parse_defaults = function(doc) {
    var defaults, even, odd, options, s, s1, s2, split, v, _, _i, _len, _ref7, _ref8;
    defaults = [];
    _ref7 = parse_section('options:', doc);
    for (_i = 0, _len = _ref7.length; _i < _len; _i++) {
      s = _ref7[_i];
      _ref8 = s.partition(':'), _ = _ref8[0], _ = _ref8[1], s = _ref8[2];
      split = ('\n' + s).split(new RegExp('\\n[ \\t]*(-\\S+?)')).slice(1);
      odd = (function() {
        var _j, _len1, _results;
        _results = [];
        for (_j = 0, _len1 = split.length; _j < _len1; _j += 2) {
          v = split[_j];
          _results.push(v);
        }
        return _results;
      })();
      even = (function() {
        var _j, _len1, _ref9, _results;
        _ref9 = split.slice(1);
        _results = [];
        for (_j = 0, _len1 = _ref9.length; _j < _len1; _j += 2) {
          v = _ref9[_j];
          _results.push(v);
        }
        return _results;
      })();
      split = (function() {
        var _j, _len1, _ref10, _ref9, _results;
        _ref9 = zip(odd, even);
        _results = [];
        for (_j = 0, _len1 = _ref9.length; _j < _len1; _j++) {
          _ref10 = _ref9[_j], s1 = _ref10[0], s2 = _ref10[1];
          _results.push(s1 + s2);
        }
        return _results;
      })();
      options = (function() {
        var _j, _len1, _results;
        _results = [];
        for (_j = 0, _len1 = split.length; _j < _len1; _j++) {
          s = split[_j];
          if (s.startsWith('-')) {
            _results.push(Option.parse(s));
          }
        }
        return _results;
      })();
      defaults.push.apply(defaults, options);
    }
    return defaults;
  };

  formal_usage = function(section) {
    var pu, s, _, _ref7;
    _ref7 = section.partition(':'), _ = _ref7[0], _ = _ref7[1], section = _ref7[2];
    pu = section._split();
    return '( ' + ((function() {
      var _i, _len, _ref8, _results;
      _ref8 = pu.slice(1);
      _results = [];
      for (_i = 0, _len = _ref8.length; _i < _len; _i++) {
        s = _ref8[_i];
        _results.push(s === pu[0] ? ') | (' : s);
      }
      return _results;
    })()).join(' ') + ' )';
  };

  extras = function(help, version, options, doc) {
    var o;
    if (help && any((function() {
      var _i, _len, _ref7, _results;
      _results = [];
      for (_i = 0, _len = options.length; _i < _len; _i++) {
        o = options[_i];
        _results.push(((_ref7 = o.name) === '--help' || _ref7 === '-h') && o.value);
      }
      return _results;
    })())) {
      return doc.replace(/^\s*|\s*$/, '');
    }
    if (version && any((function() {
      var _i, _len, _results;
      _results = [];
      for (_i = 0, _len = options.length; _i < _len; _i++) {
        o = options[_i];
        _results.push((o.name === '--version') && o.value);
      }
      return _results;
    })())) {
      return version;
    }
    return "";
  };

  Dict = (function(_super) {
    __extends(Dict, _super);

    function Dict(pairs) {
      var key, value, _i, _len, _ref7;
      for (_i = 0, _len = pairs.length; _i < _len; _i++) {
        _ref7 = pairs[_i], key = _ref7[0], value = _ref7[1];
        this[key] = value;
      }
    }

    Dict.prototype.toObject = function() {
      var dict, name, _i, _len, _ref7;
      dict = {};
      _ref7 = Object.keys(this).sort();
      for (_i = 0, _len = _ref7.length; _i < _len; _i++) {
        name = _ref7[_i];
        dict[name] = this[name];
      }
      return dict;
    };

    return Dict;

  })(Object);

  docopt = function(doc, kwargs) {
    var a, allowedargs, arg, argv, collected, doc_options, e, exit, help, i, left, matched, name, options, options_first, options_shortcut, output, pattern, pattern_options, pattern_options_strings, usage_sections, version, _i, _len, _ref7, _ref8;
    if (kwargs == null) {
      kwargs = {};
    }
    allowedargs = ['argv', 'name', 'help', 'version', 'options_first', 'exit'];
    for (arg in kwargs) {
      if (__indexOf.call(allowedargs, arg) < 0) {
        throw new Error("unrecognized argument to docopt: ");
      }
    }
    argv = kwargs.argv === void 0 ? process.argv.slice(2) : kwargs.argv;
    name = kwargs.name === void 0 ? null : kwargs.name;
    help = kwargs.help === void 0 ? true : kwargs.help;
    version = kwargs.version === void 0 ? null : kwargs.version;
    options_first = kwargs.options_first === void 0 ? false : kwargs.options_first;
    exit = kwargs.exit === void 0 ? true : kwargs.exit;
    try {
      usage_sections = parse_section('usage:', doc);
      if (usage_sections.length === 0) {
        throw new DocoptLanguageError('"usage:" (case-insensitive) not found.');
      }
      if (usage_sections.length > 1) {
        throw new DocoptLanguageError('More than one "usage:" (case-insensitive).');
      }
      DocoptExit.usage = usage_sections[0];
      options = parse_defaults(doc);
      pattern = parse_pattern(formal_usage(DocoptExit.usage), options);
      argv = parse_argv(new Tokens(argv), options, options_first);
      pattern_options = pattern.flat(Option);
      _ref7 = pattern.flat(OptionsShortcut);
      for (_i = 0, _len = _ref7.length; _i < _len; _i++) {
        options_shortcut = _ref7[_i];
        doc_options = parse_defaults(doc);
        pattern_options_strings = (function() {
          var _j, _len1, _results;
          _results = [];
          for (_j = 0, _len1 = pattern_options.length; _j < _len1; _j++) {
            i = pattern_options[_j];
            _results.push(i.toString());
          }
          return _results;
        })();
        options_shortcut.children = doc_options.filter(function(item) {
          var _ref8;
          return _ref8 = item.toString(), __indexOf.call(pattern_options_strings, _ref8) < 0;
        });
      }
      output = extras(help, version, argv, doc);
      if (output) {
        if (exit) {
          print(output);
          process.exit();
        } else {
          throw new Error(output);
        }
      }
      _ref8 = pattern.fix().match(argv), matched = _ref8[0], left = _ref8[1], collected = _ref8[2];
      if (matched && left.length === 0) {
        return new Dict((function() {
          var _j, _len1, _ref9, _results;
          _ref9 = [].concat(pattern.flat(), collected);
          _results = [];
          for (_j = 0, _len1 = _ref9.length; _j < _len1; _j++) {
            a = _ref9[_j];
            _results.push([a.name, a.value]);
          }
          return _results;
        })()).toObject();
      }
      throw new DocoptExit(DocoptExit.usage);
    } catch (_error) {
      e = _error;
      if (!exit) {
        throw e;
      } else {
        if (e.message) {
          print(e.message);
        }
        return process.exit(1);
      }
    }
  };

  module.exports = {
    docopt: docopt,
    DocoptLanguageError: DocoptLanguageError,
    DocoptExit: DocoptExit,
    Option: Option,
    Argument: Argument,
    Command: Command,
    Required: Required,
    OptionsShortcut: OptionsShortcut,
    Either: Either,
    Optional: Optional,
    Pattern: Pattern,
    OneOrMore: OneOrMore,
    Tokens: Tokens,
    Dict: Dict,
    transform: transform,
    formal_usage: formal_usage,
    parse_section: parse_section,
    parse_defaults: parse_defaults,
    parse_pattern: parse_pattern,
    parse_long: parse_long,
    parse_shorts: parse_shorts,
    parse_argv: parse_argv
  };

}).call(this);
